sanity check can fail for packages missing dependencies

Bug #1654070 reported by Brian Murray on 2017-01-04
10
This bug affects 1 person
Affects Status Importance Assigned to Milestone
unattended-upgrades (Ubuntu)
Medium
Brian Murray
Xenial
Undecided
Unassigned

Bug Description

I've been getting mail for days about pulseaudio-module-gconf and -module-zeroconf being upgraded, come to find out its not really happening.

bdmurray@flash:~$ sudo /usr/bin/unattended-upgrade --debug --verbose
Initial blacklisted packages: nvidia-304
Initial whitelisted packages:
Starting unattended upgrades script
Allowed origins are: ['o=Ubuntu,a=xenial', 'o=Ubuntu,a=xenial-security', 'o=Ubuntu,a=xenial-updates']
Checking: pulseaudio-module-gconf ([<Origin component:'universe' archive:'xenial-updates' origin:'Ubuntu' label:'Ubuntu' site:'192.168.10.7' isTrusted:True>])
Checking: pulseaudio-module-zeroconf ([<Origin component:'universe' archive:'xenial-updates' origin:'Ubuntu' label:'Ubuntu' site:'192.168.10.7' isTrusted:True>])
pkgs that look like they should be upgraded: pulseaudio-module-gconf
pulseaudio-module-zeroconf
Fetched 0 B in 0s (0 B/s)
fetch.run() result: 0
blacklist: ['nvidia-304']
whitelist: []
Checking the black and whitelist: pulseaudio-module-gconf
Checking the black and whitelist: pulseaudio-module-zeroconf
Packages that will be upgraded: pulseaudio-module-gconf pulseaudio-module-zeroconf
Writing dpkg log to '/var/log/unattended-upgrades/unattended-upgrades-dpkg.log'
All upgrades installed
InstCount=0 DelCount=0 BrokenCount=0
Extracting content from '/var/log/unattended-upgrades/unattended-upgrades-dpkg.log' since '2017-01-04 12:27:12'
Sending mail to '<email address hidden>'
mail returned: 0
bdmurray@flash:~$ apt-cache policy pulseaudio-module-gconf
pulseaudio-module-gconf:
  Installed: 1:8.0-0ubuntu3
  Candidate: 1:8.0-0ubuntu3.1
  Version table:
     1:8.0-0ubuntu3.1 500
        500 http://192.168.10.7/ubuntu xenial-updates/universe amd64 Packages
 *** 1:8.0-0ubuntu3 500
        500 http://192.168.10.7/ubuntu xenial/universe amd64 Packages
        100 /var/lib/dpkg/status

Brian Murray (brian-murray) wrote :

This still happens with the Zesty version of unattended-upgrades on Xenial so bears further investigation.

tags: added: xenial zesty
Brian Murray (brian-murray) wrote :

Ah, running with --apt-debug is more informative.

bdmurray@flash:~$ sudo /usr/bin/unattended-upgrade -v --apt-debug
Initial blacklisted packages: nvidia-304
Initial whitelisted packages:
Starting unattended upgrades script
Allowed origins are: ['o=Ubuntu,a=xenial', 'o=Ubuntu,a=xenial-security', 'o=Ubuntu,a=xenial-updates']
  pulseaudio-module-gconf:amd64 Depends on libpulse0 [ amd64 ] < 1:8.0-0ubuntu3 > ( libs ) (= 1:8.0-0ubuntu3.1) can't be satisfied!
  pulseaudio-module-zeroconf:amd64 Depends on libpulse0 [ amd64 ] < 1:8.0-0ubuntu3 > ( libs ) (= 1:8.0-0ubuntu3.1) can't be satisfied!
  pulseaudio-module-gconf:amd64 Depends on libpulse0 [ amd64 ] < 1:8.0-0ubuntu3 > ( libs ) (= 1:8.0-0ubuntu3.1) can't be satisfied!
  pulseaudio-module-zeroconf:amd64 Depends on libpulse0 [ amd64 ] < 1:8.0-0ubuntu3 > ( libs ) (= 1:8.0-0ubuntu3.1) can't be satisfied!
Packages that will be upgraded: pulseaudio-module-gconf pulseaudio-module-zeroconf
Writing dpkg log to '/var/log/unattended-upgrades/unattended-upgrades-dpkg.log'
All upgrades installed

If the dependencies can't be satisfied we shouldn't say that the package will be upgraded.

Brian Murray (brian-murray) wrote :

For some reason on this particular system libpulse0 from xenial-updates isn't found.

bdmurray@flash:~$ apt-cache policy libpulse0
libpulse0:
  Installed: 1:8.0-0ubuntu3
  Candidate: 1:8.0-0ubuntu3
  Version table:
 *** 1:8.0-0ubuntu3 500
        500 http://192.168.10.7/ubuntu xenial/main amd64 Packages
        100 /var/lib/dpkg/status

Although the gconf module update is found.

bdmurray@flash:~$ apt-cache policy pulseaudio-module-gconf
pulseaudio-module-gconf:
  Installed: 1:8.0-0ubuntu3
  Candidate: 1:8.0-0ubuntu3.1
  Version table:
     1:8.0-0ubuntu3.1 500
        500 http://192.168.10.7/ubuntu xenial-updates/universe amd64 Packages
 *** 1:8.0-0ubuntu3 500
        500 http://192.168.10.7/ubuntu xenial/universe amd64 Packages
        100 /var/lib/dpkg/status

Another system using the same mirror is fine.

 $ apt-cache policy libpulse0
libpulse0:
  Installed: 1:8.0-0ubuntu3.1
  Candidate: 1:8.0-0ubuntu3.1
  Version table:
 *** 1:8.0-0ubuntu3.1 500
        500 http://192.168.10.7/ubuntu xenial-updates/main amd64 Packages
        100 /var/lib/dpkg/status
     1:8.0-0ubuntu3 500
        500 http://192.168.10.7/ubuntu xenial/main amd64 Packages

summary: - lies about upgrading pulseaudio-module-gconf
+ sanity check can fail for packages missing dependencies
Changed in unattended-upgrades (Ubuntu):
status: New → Triaged
importance: Undecided → Medium
assignee: nobody → Brian Murray (brian-murray)
Brian Murray (brian-murray) wrote :

Emails from unattended-upgrades are saner now with my patch:

Packages that were upgraded:
 libnss3 libnss3-nssdb
Packages with upgradable origin but kept back:
 pulseaudio-module-gconf pulseaudio-module-zeroconf

As opposed to:

Packages that were upgraded:
 libnss3 libnss3-nssdb pulseaudio-module-gconf
 pulseaudio-module-zeroconf

And then the pulseaudio packages not being installed.

Changed in unattended-upgrades (Ubuntu):
milestone: none → ubuntu-17.03
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package unattended-upgrades - 0.93.1ubuntu1

---------------
unattended-upgrades (0.93.1ubuntu1) zesty; urgency=medium

  [ Brian Murray ]
  * When performing a sanity check for packages to install or upgrade return
    false when either there are no packages in the cache or the package to
    upgrade is not in the change set. (LP: #1654070)
  * Do not mark packages for deletion / autoremoval if unattended-upgrades is
    being run in dry-run mode. (LP: #1544942)

  [ Louis Bouchard ]
  * Store delay command line option as an int not a string since we do maths
    with it.

 -- Brian Murray <email address hidden> Fri, 06 Jan 2017 13:00:24 -0800

Changed in unattended-upgrades (Ubuntu):
status: Triaged → Fix Released

Hello Brian, or anyone else affected,

Accepted unattended-upgrades into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/unattended-upgrades/1.1ubuntu1.18.04.7~16.04.0 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-xenial to verification-done-xenial. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-xenial. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

Changed in unattended-upgrades (Ubuntu Xenial):
status: New → Fix Committed
tags: added: verification-needed verification-needed-xenial
Łukasz Zemczak (sil2100) wrote :

Hello Brian, or anyone else affected,

Accepted unattended-upgrades into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/unattended-upgrades/1.1ubuntu1.18.04.7~16.04.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-xenial to verification-done-xenial. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-xenial. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance for helping!

N.B. The updated package will be released to -updates after the bug(s) fixed by this package have been verified and the package has been in -proposed for a minimum of 7 days.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers